#
# test01.rb
#
# $Id: test01.rb,v 1.1 2000/11/22 14:35:59 keiko Exp $
#

require "narray"
require "dcl"

include DCL
include Math


NX = 19
NY = 19
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = +90
DX1 = 20
DX2 = 60
DY1 = 10
DY2 = 30
DRAD = PI / 180
DZ = 0.05
DP = 0.2
p = NArray.new(Float, NX, NY)

#-- data ---
for j in 0..NY-1
  for i in 0..NX-1
    alon = (XMIN + (XMAX-XMIN)*i/(NX-1)) * DRAD
    alat = (YMIN + (YMAX-YMIN)*j/(NY-1)) * DRAD
    slat = sin(alat)
    p[i,j] = cos(alon) * (1-slat**2) * sin(2*PI*slat) + DZ
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

rmiss = glrget('RMISS')
sglset('LSOFTF', false)

grfrm
grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uestlv(rmiss, -DP, 201)
uestlv(DP, DP*2, 401)
uestlv(DP*2, rmiss, 402)
uetone(p, NX, NX, NY)

uxaxdv('B', DX1, DX2)
uxaxdv('T', DX1, DX2)
uxsttl('B', 'LONGITUDE', 0.0)

uyaxdv('L', DY1, DY2)
uyaxdv('R', DY1, DY2)
uysttl('L', 'LATITUDE', 0.0)

udgclb(p, NX, NX, NY, DP)
udcntr(p, NX, NX, NY)

grcls

