#
# u2d4.rb
#
# $Id: u2d4.rb,v 1.1 2000/11/21 03:15:31 keiko Exp $
#

require "num/numarray"
require "num/dcl"

include Num::DCL
include Math


NX = 21
NY = 21
XMIN = -10.0
XMAX = 10.0
YMIN = -10.0
YMAX = 10.0
KMAX = 5
PMIN = 0.0
PMAX = 1.0
DX = (XMAX-XMIN)/(NX-1)
DY = (YMAX-YMIN)/(NY-1)
DP = (PMAX-PMIN)/KMAX

u = NumArray.new(Float, NX, NY)
v = NumArray.new(Float, NX, NY)
p = NumArray.new(Float, NX, NY)


#-- data ----
for j in 0..NY-1
  for i in 0..NX-1
    xi = XMIN + i*DX
    yj = YMIN + j*DY
    u[i, j] = xi
    v[i, j] = -yj
    p[i, j] = exp(-xi**2/64 - yj**2/25)
  end
end

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws
sglset('LSOFTF', true)
grfrm

grswnd(XMIN, XMAX, YMIN, YMAX)
uspfit
grstrf

usdaxs
ugvect(u, NX, v, NX, NX, NY)
udcntr(p, NX, NX, NY)

for k in 0..KMAX-1
  tlev1 = k*DP
  tlev2 = tlev1 + DP
  ipat  = 600 + k
  uestlv(tlev1, tlev2, ipat)
end

uetone(p, NX, NX, NY)

grcls

