#
# quick4.rb
#
# $Id: quick4.rb,v 1.1 2000/11/21 03:15:44 keiko Exp $
#

require "num/numarray"
require "num/dcl"

include Num::DCL
include Math


NX = 37
NY = 37
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = 90
DRAD = PI/180

p = NumArray.new(Float, NX, NY)

#-- data ----
for j in 0..NY-1
  for i in 0..NX-1
    alon = (XMIN + (XMAX-XMIN)*i/(NX-1))*DRAD
    alat = (YMIN + (YMAX-YMIN)*j/(NY-1))*DRAD
    slat = sin(alat)
    p[i,j] = 3*sqrt(1-slat**2)*slat*cos(alon) - 0.5*(3*slat**2-1)
  end
end

#-- graph ----
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws
grfrm

grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt(0.2, 0.8, 0.2, 0.8)
grstrn(1)
grstrf

uetone(p, NX, NX, NY)
usdaxs
udcntr(p, NX, NX, NY)

grcls

